/*NSRCOPYRIGHT
	Copyright (C) 1999-2011 University of Washington
	Developed by the National Simulation Resource
	Department of Bioengineering,  Box 355061
	University of Washington, Seattle, WA 98195-5061.
	Dr. J. B. Bassingthwaighte, Director
END_NSRCOPYRIGHT*/

// parser callbacks to read datagen code text

package JSim.datagen;

import JSim.util.*;
import JSim.expr.*;
import JSim.data.*;
import JSim.aserver.*;
import java.util.*;

public class DGCodeReader {
	boolean doAudit;
	
	// constructor
	public DGCodeReader() {
	    doAudit = true;
	}

	public void setVersion(String s) throws Xcept {
	    audit("setVersion " + s);
	}
	
	public void newImport(String f) throws Xcept {
	    audit("newImport" + f);
	}
	
	public void setUnitConversion(String onOff)  throws Xcept {
	    audit("setUnitConversion " + onOff);
	}
	
	public void newTask(String modelName) throws Xcept {
	    audit("newTask " + modelName);
	}
	
	public void doneTask() throws Xcept {
	    audit("doneTask");
	}
	
	public void newData(String io, String dtype, String n, Expr expr) throws Xcept {
	    audit("newData " + io + " " + dtype + " " + n + "=" + expr);
	} 

	public void doneData() throws Xcept {
	    audit("doneData");
	}
	
	public void addPropClause(String prop, Expr expr) throws Xcept {
	    audit("setPropClause " + prop + "=" + expr);
	}	
	
	public void addUnitClause(String s) throws Xcept {
	    audit("addUnitClase " + s);
	} 
	
	public void addAssignClause(String n, Expr expr) throws Xcept {
	    audit("addAssignClause " + n + "=" + expr);
	} 

	public Expr compByName(String n) throws Xcept {
	    audit("compByName " + n);
	    return null;
	} 

	public Expr funcCall(String f, Expr.List exprs) throws Xcept {
	    audit("funcCall " + f + " " + exprs);
	    return null;
	} 

	public void audit(String s) throws Xcept {
	    if (doAudit)
	    	System.err.println("parse:\t" + s);
	}
}

