/*NSRCOPYRIGHT
	Copyright (C) 1999-2011 University of Washington
	Developed by the National Simulation Resource
	Department of Bioengineering,  Box 355061
	University of Washington, Seattle, WA 98195-5061.
	Dr. J. B. Bassingthwaighte, Director
END_NSRCOPYRIGHT*/

// Named expr for DG parsing
//  may be data ref, mml var ref, or unit ref, depending on context

package JSim.datagen;

import JSim.util.*;
import JSim.expr.*;
import JSim.data.*;
import java.util.*;

public class DGNamedExpr extends NamedExpr {
	private String name;
	private int type;
	
	// type constants
	public static final int UNDEFINED = 0;
	public static final int MMLVAR = 1;
	public static final int DATAGEN = 2;
	public static final int DATACURVE = 3;
	public static final int UNIT = 4; // useful ???
	
	// constructor
	public DGNamedExpr(String name) throws Xcept {
	    super();
	    this.name = name;
	}

	// query
	public String name() { return name; }
	public int dataType() { return REAL; }
	public Unit unit() { return null; }
	public boolean sameAs(Expr expr) { return this == expr; }

	// irrelevant Expr legacy methods 
	public Expr takeDomDeriv(NamedExpr x) throws Xcept {
	    throw new Xcept(this, "takeDomDeriv() not implemented");
	}
	public Expr expandDeriv() throws Xcept {
	    throw new Xcept(this, "expandDeriv() not implemented");
	}
	public Expr unitCorrect() throws Xcept {
	    throw new Xcept(this, "unitCorrect() not implemented");
	}
	public void addDomains(Expr.List xs) {
	}	
	public String toString(Context ctxt) { return toString(); }
}

