/*NSRCOPYRIGHT
	Copyright (C) 1999-2011 University of Washington
	Developed by the National Simulation Resource
	Department of Bioengineering,  Box 355061
	University of Washington, Seattle, WA 98195-5061.
	Dr. J. B. Bassingthwaighte, Director
END_NSRCOPYRIGHT*/

// Data Generator Task

package JSim.datagen;

import JSim.util.*;
import JSim.expr.*;
import JSim.data.*;
import JSim.aserver.*;
import java.util.*;

public class DGTask {
	private String name;
	public String modelName;
	public String parsetName;
	public int runType; 
	private ArrayList<DGAssign> assigns; // par assignments

	public static final int DEFAULT_RUN_TYPE = ASModel.SINGLE;

	// constructor
	public DGTask(String name, String modelName, String parsetName) {
	    this.name = name;
	    this.modelName = modelName;
	    this.parsetName = parsetName;
	    runType = DEFAULT_RUN_TYPE;
	    assigns = new ArrayList<DGAssign>();
	}

	// add assign
	public void addAssign(DGAssign pa) {
	    assigns.add(pa);
	}

	// query
	public String name() { return name; }
	public int nassigns() { return assigns.size(); }
	public DGAssign assign(int i) { return assigns.get(i); }
	public String toString() {
	    String s = "task " + name + "(" + modelName +
	        ", " + parsetName + ")";
	    if (assigns.size() > 0)
	    	return s + " { " + assigns.get(0) + " ... }";
	    else
	    	return s + ";";
 	}
}


