package JSim.sbml;

import org.sbml.libsbml.*;
import java.io.*;

import JSim.util.*;

public class SBIDTest {

	// constructor
	public SBIDTest(String text) throws Exception {
	    SBMLReader rdr = new SBMLReader();
	    SBMLDocument doc = rdr.readSBMLFromString(text);
	    Model model = doc.getModel();
	    for (int i=0; i<model.getNumReactions(); i++) {
	    	Reaction r = model.getReaction(i);
		System.err.println("Reaction id=" + r.getId());
	    }
	}
	
	// mainline
	public static void main(String[] args) throws Exception {
	    System.loadLibrary("sbmlj");
	    for (int i=0; i<args.length; i++) {
	    	File f = new File(args[i]);
		System.err.println("==== " + f);
		String text = UtilIO.readText(f);
		new SBIDTest(text);
	    }
	}
}

