/*NSRCOPYRIGHT
	Copyright (C) 1999-2011 University of Washington
	Developed by the National Simulation Resource
	Department of Bioengineering,  Box 355061
	University of Washington, Seattle, WA 98195-5061.
	Dr. J. B. Bassingthwaighte, Director
END_NSRCOPYRIGHT*/

// test thread lock flag

package JSim.tests; 

import JSim.util.*;
import java.io.*;
import java.sql.*;

public class TestSQL {
	// mainline
	public static void main(String[] args) throws Exception {
	    if (args.length != 2) throw new Xcept(
	    	"Usage: TestSQL user-name db-name");
	    String userName = args[0];
	    String dbName = args[1];
	
	    Class.forName("com.mysql.jdbc.Driver");
	    String uri =
	       "jdbc:mysql://localhost/" + 
	       dbName + "?" + "user=" + userName;
	    Connection conn = DriverManager.getConnection(uri);
	    Statement stmt = conn.createStatement();

	    String sql = "DELETE FROM ontology WHERE ontology='Zork'";
System.err.println(sql);
 	    int ct = stmt.executeUpdate(sql);
	    System.err.println("delete ct=" + ct);
	    
	    sql = "INSERT INTO ontology(ontology, ontology_name) "
	    	+ "VALUES ('zork', 'Zelda')";
System.err.println(sql);
 	    ct = stmt.executeUpdate(sql);
	    System.err.println("update ct=" + ct);
	    
	    sql = "SELECT * FROM ontology";
System.err.println(sql);
	    ResultSet rs  = stmt.executeQuery(sql);
	    while (rs.next()) {
	    	String ont = rs.getString("ontology");
	    	String name = rs.getString("ontology_name");
		System.err.println(ont + " " + name);
	    }

	    stmt.close();
	}
}


