// This model generated automatically from SBML

// unit definitions
import nsrunit;
unit conversion off;

// SBML property definitions
property sbmlRole=string;
property sbmlName=string;
property sbmlCompartment=string;

// SBML reactions
// reaction1: S1 <=> S2 
// reaction2: S2 <=> S1 
// reaction3: S2 <=> S3 S4 
// reaction4: S3 S4 <=> S2 

math main {
  realDomain time second;
  time.min=0;
  extern time.max;
  extern time.delta;

  // variable definitions
  real compartment = 1 L;
  real k1 = .75;
  real k2 = .25;
  real k3 = .1;
  real k4 = .1;
  real S1(time) M;
  real S2 M;
  real S3(time) M;
  real S4(time) M;
  real reaction1(time) katal;
  real reaction2(time) katal;
  real reaction3(time) katal;
  real reaction4(time) katal;

  // equations
  when (time=time.min) S1 = .1/compartment;
  (S1*compartment):time = -1*reaction1 + reaction2;
  S2 = .2/compartment;
  when (time=time.min) S3 = 0;
  (S3*compartment):time = reaction3 + -1*reaction4;
  when (time=time.min) S4 = 0;
  (S4*compartment):time = reaction3 + -1*reaction4;
  reaction1 = compartment*k1*S1;
  reaction2 = compartment*k2*S2;
  reaction3 = compartment*k3*S2;
  reaction4 = compartment*k4*S3*S4;

  // variable properties
  compartment.sbmlRole="compartment";
  k1.sbmlRole="parameter";
  k2.sbmlRole="parameter";
  k3.sbmlRole="parameter";
  k4.sbmlRole="parameter";
  S1.sbmlRole="species";
  S1.sbmlCompartment="compartment";
  S2.sbmlRole="species";
  S2.sbmlCompartment="compartment";
  S3.sbmlRole="species";
  S3.sbmlCompartment="compartment";
  S4.sbmlRole="species";
  S4.sbmlCompartment="compartment";
  reaction1.sbmlRole="rate";
  reaction2.sbmlRole="rate";
  reaction3.sbmlRole="rate";
  reaction4.sbmlRole="rate";
}

