// This model generated automatically from SBML

// unit definitions
import nsrunit;
unit conversion off;

// SBML property definitions
property sbmlRole=string;
property sbmlName=string;
property sbmlCompartment=string;

// SBML reactions
// in: X0 => T 
// out: T => X1 

math main {
  realDomain time second;
  time.min=0;
  extern time.max;
  extern time.delta;

  // variable definitions
  real cell = 1 L;
  real Keq = 2.5;
  real X0(time) M;
  real X1(time) M;
  real T(time) M;
  real S1(time) M;
  real S2(time) M;
  real in(time) katal;
  real k1 = .1;
  real out(time) katal;
  real k2 = .15;

  // equations
  when (time=time.min) X0 = 1;
  (X0*cell):time = -1*in;
  when (time=time.min) X1 = 0;
  (X1*cell):time = out;
  when (time=time.min) T = 0;
  (T*cell):time = in + -1*out;
  S1 = T/(1+Keq);
  S2 = Keq*S1;
  in = k1*X0;
  out = k2*S2;

  // variable properties
  cell.sbmlRole="compartment";
  Keq.sbmlRole="parameter";
  X0.sbmlRole="species";
  X0.sbmlCompartment="cell";
  X1.sbmlRole="species";
  X1.sbmlCompartment="cell";
  T.sbmlRole="species";
  T.sbmlCompartment="cell";
  S1.sbmlRole="species";
  S1.sbmlCompartment="cell";
  S2.sbmlRole="species";
  S2.sbmlCompartment="cell";
  in.sbmlRole="rate";
  k1.sbmlRole="parameter";
  out.sbmlRole="rate";
  k2.sbmlRole="parameter";
}

